const { __glob } = require("./global-variables")
const { LogType } = require("../modules/sub-log")
const fs = require("fs")

const nlog = new LogType("Node-Finder")

module.exports.getNodes = function () {
        nlog.step.init("find_nodes", "Récupération des nodes de la base de donnée")
        
        if(fs.existsSync(__glob.NODES)) {
            try {  

                var nodes_data = JSON.parse(fs.readFileSync(__glob.NODES))
                const nodes_array = new Array()

                for(node of nodes_data) {
                    nodes_array.push(node)

                }
                
                nlog.log("Récupération de " + nodes_array.length + " nodes dans la base de donnée !")
                nlog.step.end("find_nodes")
                return nodes_array
            } catch(error) {
                nlog.step.error("find_nodes", error)

            }
        } else {

            nlog.warn("Fichier de configuration introuvable !")
            
            try {
                var nodes = {}

               
                fs.writeFileSync(__glob.NODES, JSON.stringify(nodes, null, 2))
                nlog.log("Création d'un fichier de base de donnée de nodes ! Redémarrage de l'application nécéssaire !")
                nlog.step.error("find_nodes", "Redémarrage requis pour lire la nouvelle base de donnée des nodes !")
                process.exit(0)
            } catch(error) {
                nlog.step.error("find_nodes", "Tentative de création du fichier de base de donnée nodes échoué !"  + error)

            }
        }

}

module.exports.addNodes = function (data) {

    nlog.step.init("add_nodes", "Ajout d'un nouveau noeud dans la base de donnée de nodes : " + data.host)
        
    if(fs.existsSync(__glob.NODES)) {
        try {  

            var nodes_data = JSON.parse(fs.readFileSync(__glob.NODES))
            
            nodes_data.push(data)
            fs.writeFileSync(__glob.NODES, JSON.stringify(nodes_data, null, 2))
           
            nlog.step.end("add_nodes")

          
        } catch(error) {
            nlog.step.error("add_nodes", error)

        }
    } else {

        nlog.warn("Fichier de configuration introuvable !")
        
        try {
            var nodes = []

           
            fs.writeFileSync(__glob.NODES, JSON.stringify(nodes, null, 2))
            nlog.log("Création d'un fichier de base de donnée de nodes ! Redémarrage de l'application nécéssaire !")
            nlog.step.error("add_nodes", "Redémarrage requis pour lire la nouvelle base de donnée des nodes !")
            process.exit(0)
        } catch(error) {
            nlog.step.error("add_nodes", "Tentative de création du fichier de nodes échoué !"  + error)

        }
    }
}

